Crazy Eddies GUI System: TiXmlNode Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Class List
- Alphabetical List
- Class Hierarchy
- Class Members

# TiXmlNode Class Reference

Inheritance diagram for TiXmlNode:

[legend]
Collaboration diagram for TiXmlNode:

[legend]
List of all members.

## Public Types
enum | NodeType { DOCUMENT, ELEMENT, COMMENT, UNKNOWN, TEXT, DECLARATION, TYPECOUNT }
## Public Member Functions
const char * | Value () const
void | SetValue (const char *_value)
void | Clear ()
| Delete all the children of this node. Does not affect 'this'.
TiXmlNode * | Parent ()
| One step up the DOM.
const TiXmlNode * | Parent () const
const TiXmlNode * | FirstChild () const
| The first child of this node. Will be null if there are no children.
TiXmlNode * | FirstChild ()
const TiXmlNode * | FirstChild (const char *value) const
| The first child of this node with the matching 'value'. Will be null if none found.
TiXmlNode * | FirstChild (const char *value)
| The first child of this node with the matching 'value'. Will be null if none found.
const TiXmlNode * | LastChild () const
TiXmlNode * | LastChild ()
| The last child of this node. Will be null if there are no children.
const TiXmlNode * | LastChild (const char *value) const
TiXmlNode * | LastChild (const char *value)
| The last child of this node matching 'value'. Will be null if there are no children.
const TiXmlNode * | IterateChildren (TiXmlNode *previous) const
TiXmlNode * | IterateChildren (TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const char *value, TiXmlNode *previous) const
| This flavor of IterateChildren searches for children with a particular 'value'.
TiXmlNode * | IterateChildren (const char *value, TiXmlNode *previous)
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
bool | RemoveChild (TiXmlNode *removeThis)
| Delete a child of this node.
const TiXmlNode * | PreviousSibling () const
| Navigate to a sibling node.
TiXmlNode * | PreviousSibling ()
const TiXmlNode * | PreviousSibling (const char *) const
| Navigate to a sibling node.
TiXmlNode * | PreviousSibling (const char *)
const TiXmlNode * | NextSibling () const
| Navigate to a sibling node.
TiXmlNode * | NextSibling ()
const TiXmlNode * | NextSibling (const char *) const
| Navigate to a sibling node with the given 'value'.
TiXmlNode * | NextSibling (const char *)
const TiXmlElement * | NextSiblingElement () const
TiXmlElement * | NextSiblingElement ()
const TiXmlElement * | NextSiblingElement (const char *) const
TiXmlElement * | NextSiblingElement (const char *)
const TiXmlElement * | FirstChildElement () const
| Convenience function to get through elements.
TiXmlElement * | FirstChildElement ()
const TiXmlElement * | FirstChildElement (const char *value) const
| Convenience function to get through elements.
TiXmlElement * | FirstChildElement (const char *value)
virtual int | Type () const
const TiXmlDocument * | GetDocument () const
TiXmlDocument * | GetDocument ()
bool | NoChildren () const
| Returns true if this node has no children.
const TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null not of the requested type.
const TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null not of the requested type.
const TiXmlComment * | ToComment () const
| Cast to a more defined type. Will return null not of the requested type.
const TiXmlUnknown * | ToUnknown () const
| Cast to a more defined type. Will return null not of the requested type.
const TiXmlText * | ToText () const
| Cast to a more defined type. Will return null not of the requested type.
const TiXmlDeclaration * | ToDeclaration () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlDocument * | ToDocument ()
| Cast to a more defined type. Will return null not of the requested type.
TiXmlElement * | ToElement ()
| Cast to a more defined type. Will return null not of the requested type.
TiXmlComment * | ToComment ()
| Cast to a more defined type. Will return null not of the requested type.
TiXmlUnknown * | ToUnknown ()
| Cast to a more defined type. Will return null not of the requested type.
TiXmlText * | ToText ()
| Cast to a more defined type. Will return null not of the requested type.
TiXmlDeclaration * | ToDeclaration ()
| Cast to a more defined type. Will return null not of the requested type.
virtual TiXmlNode * | Clone () const =0
## Protected Member Functions
| TiXmlNode (NodeType _type)
void | CopyTo (TiXmlNode *target) const
TiXmlNode * | Identify (const char *start, TiXmlEncoding encoding)
const TIXML_STRING & | SValue () const
## Protected Attributes
TiXmlNode * | parent
NodeType | type
TiXmlNode * | firstChild
TiXmlNode * | lastChild
TIXML_STRING | value
TiXmlNode * | prev
TiXmlNode * | next
## Friends
class | TiXmlDocument
class | TiXmlElement
TIXML_OSTREAM & | operator<< (TIXML_OSTREAM &out, const TiXmlNode &base)

## Detailed Description

The parent class for everything in the Document Object Model. (Except for attributes). Nodes have siblings, a parent, and children. A node can be in a document, or stand on its own. The type of a TiXmlNode can be queried, and it can be cast to its more defined type.

## Member Enumeration Documentation

enum TiXmlNode::NodeType

| The types of XML nodes supported by TinyXml. (All the unsupported types are picked up by UNKNOWN.)

## Member Function Documentation

virtual TiXmlNode* TiXmlNode::Clone | ( |  | ) | const`[pure virtual]`

| Create an exact duplicate of this node and return it. The memory must be deleted by the caller. Implemented in TiXmlElement, TiXmlComment, TiXmlText, TiXmlDeclaration, TiXmlUnknown, and TiXmlDocument.

const TiXmlDocument * TiXmlNode::GetDocument | ( |  | ) | const

| Return a pointer to the Document this node lives in. Returns null if not in a document.

TiXmlNode * TiXmlNode::InsertAfterChild | ( | TiXmlNode * | afterThis,
|  | const TiXmlNode & | addThis
| ) |

| Add a new node related to this. Adds a child after the specified child. Returns a pointer to the new object or NULL if an error occured.

TiXmlNode * TiXmlNode::InsertBeforeChild | ( | TiXmlNode * | beforeThis,
|  | const TiXmlNode & | addThis
| ) |

| Add a new node related to this. Adds a child before the specified child. Returns a pointer to the new object or NULL if an error occured.

TiXmlNode * TiXmlNode::InsertEndChild | ( | const TiXmlNode & | addThis | ) |

| Add a new node related to this. Adds a child past the LastChild. Returns a pointer to the new object or NULL if an error occured.

const TiXmlNode * TiXmlNode::IterateChildren | ( | TiXmlNode * | previous | ) | const

| An alternate way to walk the children of a node. One way to iterate over nodes is:
    			for( child = parent->FirstChild(); child; child = child->NextSibling() )
IterateChildren does the same thing with the syntax:
    			child = 0;
    			while( child = parent->IterateChildren( child ) )
IterateChildren takes the previous child as input and finds the next one. If the previous child is null, it returns the first. IterateChildren will return null when done.

TiXmlNode * TiXmlNode::LinkEndChild | ( | TiXmlNode * | addThis | ) |

| Add a new node related to this. Adds a child past the LastChild. NOTE: the node to be added is passed by pointer, and will be henceforth owned (and deleted) by tinyXml. This method is efficient and avoids an extra copy, but should be used with care as it uses a different memory model than the other insert functions. See also: InsertEndChild

const TiXmlElement * TiXmlNode::NextSiblingElement | ( | const char * |  | ) | const

| Convenience function to get through elements. Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

const TiXmlElement * TiXmlNode::NextSiblingElement | ( |  | ) | const

| Convenience function to get through elements. Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

TiXmlNode * TiXmlNode::ReplaceChild | ( | TiXmlNode * | replaceThis,
|  | const TiXmlNode & | withThis
| ) |

| Replace a child of this node. Returns a pointer to the new object or NULL if an error occured.

void TiXmlNode::SetValue | ( | const char * | _value | ) | `[inline]`

| Changes the value of the node. Defined as:
    		Document:	filename of the xml file
    		Element:	name of the element
    		Comment:	the comment text
    		Unknown:	the tag contents
    		Text:		the text string

virtual int TiXmlNode::Type | ( |  | ) | const`[inline, virtual]`

| Query the type (as an enumerated value, above) of this node. The possible types are: DOCUMENT, ELEMENT, COMMENT, UNKNOWN, TEXT, and DECLARATION.

const char* TiXmlNode::Value | ( |  | ) | const`[inline]`

| The meaning of 'value' changes for the specific type of TiXmlNode.
    		Document:	filename of the xml file
    		Element:	name of the element
    		Comment:	the comment text
    		Unknown:	the tag contents
    		Text:		the text string
The subclasses will wrap this function.